%{
/* temp_y.y
	Yacc syntactical description of templates.
*/

#include "repsym.h"
extern symAssocType symbol_table[];
extern symAssocIdxType symbol_indices;
extern unsigned char current_card_type[];
int symbol_table_len;
int temp_lineno;

unsigned char *get_value(unsigned char *);

int copy_out;

extern int get_value_return;
int temp_lex_return;

//extern 
unsigned char err_str[20][100];

#include <stdio.h>
extern FILE *fd_hif;
FILE *temp_fd;
unsigned char tmp_hif[1000000];
int tmp_count = 0;
int tmp_to_template[100000];
int eval_error;

extern unsigned char *card_blocks[50];
extern unsigned char *field_blocks[50];
extern unsigned char *switch_blocks[50];

typedef unsigned char *charptr;
#define YYSTYPE charptr

#include "temp_l.c"

%}

%start template
%token  OTHER_LINE END_IF IF_LINE

%%

template: statements
	;

statements: /* nothing */
	| statements statement
	;

statement: OTHER_LINE
		{
			if (copy_out) {
				eval_error = 0;
				temp_lineno = yylineno;
				eval_expr(yytext,symbol_table,&symbol_indices,symbol_table_len);
				if (eval_error == 1) return 1;
			}
		}
	| IF_LINE 
		{
			$$ = (unsigned char *) "COPY";
			eval_error = 0;
			temp_lineno = yylineno;
			if (copy_out && !eval_expr(yytext,symbol_table,&symbol_indices,symbol_table_len)) {
				copy_out = 0;
				$$ = (unsigned char *) "NO_COPY";
#ifdef TEMP_DEBUG
				printf("\n***Turning OFF copy.\n");
#endif
			}
			if (eval_error == 1) return 1;
			
		}
	statements END_IF 
		{
			if (!copy_out && !strcmp($2,"NO_COPY")) {
				copy_out = 1;
#ifdef TEMP_DEBUG
				printf("\n***Turning ON copy.\n");
#endif
			}
		}
	;

%%

#define TEMP 20

yyerror()
{
	if (!temp_lex_return) {
	  //s
		printf(err_str[0],"Template syntax error on line %d: %s.",yylineno,yytext);
		//s
		printf(err_str[1],"");
		//rep_error(TEMP);
	}
}

read_template()
{
	int yret;

	tmp_hif[0] = '\0';
	memset(tmp_to_template,0,sizeof(tmp_to_template));
	tmp_count = 0;
	yret = 0;
	yychar = -1;
//	yyerrflag = 0;
//	yyprevious = YYNEWLINE;

	temp_lex_return = 0;

	yylineno = 1;

	if ((temp_fd = fopen(current_card_type,"r")) == NULL) {
		sprintf(err_str[0],"No template available for card %s.", current_card_type);
		sprintf(err_str[1],"");
		rep_error(TEMP);
		return 1;
	}
	symbol_table_len = symbol_indices.last;
	copy_out = 1;
	yyin = temp_fd;

	memset(card_blocks,0,sizeof(card_blocks));
	memset(field_blocks,0,sizeof(field_blocks));
	memset(switch_blocks,0,sizeof(switch_blocks));

	yret = temp_parse();

	fclose(temp_fd);
	if (temp_lex_return) return 1;
	return yret;
}

read_top_stack()
{
	tmp_hif[0] = '\0';
	memset(tmp_to_template,0,sizeof(tmp_to_template));
	tmp_count = 0;

	yylineno = 1;

	temp_lex_return = 0;

	if ((temp_fd = fopen("STACK_TOP","r")) == NULL) {
		printf("No STACK_TOP file. Exiting.\n");
		exit(1);
	}
	symbol_table_len = symbol_indices.last;
	copy_out = 1;
	yyin = temp_fd;
	temp_parse();
	fclose(temp_fd);
}
